#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <netdb.h>
#define PORTNUMBER  12345
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <signal.h>
#include <linux/types.h>
#include <linux/videodev.h>
#include <errno.h>
#include <time.h>

#define COLS      64*2
#define ROWS      48*2

int cam,size,i,frame,q,st;

unsigned char *bigbuf;
unsigned char *buf;
int gray[3];


int main (int argc, char *argv[])
{
	int n, s, len;
	int *len2;
	struct video_capability cap;
	struct video_picture pic;
	struct video_window win;
	struct video_capture vicap;
	struct video_channel vidcan;
	struct video_mbuf vidbuf;
	struct video_buffer buffer;
	struct video_mmap mapbuf;
	char hostname[64];
	struct hostent *hp;
	struct sockaddr_in name;

    /* Get our local host name.  */
	gethostname(hostname, sizeof(hostname));

    /* Look up our host's network address. */
	hp = gethostbyname(hostname);

    /* Create a socket in the INET domain.  */
	s = socket(AF_INET, SOCK_DGRAM, 0);

    /* Create the address of the server. */
	name.sin_family = AF_INET;
	name.sin_port = htons(PORTNUMBER);
	memcpy(&name.sin_addr, hp->h_addr_list[0], hp->h_length);
	len = sizeof(struct sockaddr_in);

	name.sin_addr.s_addr = inet_addr(argv[1]);


//-------------------------------------------------------------------
              /* abriendo dispositivo de video */
//-------------------------------------------------------------------

	cam = open("/dev/video0", O_RDWR );

	if (cam<0){printf("ERROR: NO HAY UNA CAMARA CONECTADA\n");
		exit(-1);}

//--------------------------------------------------------------------
		/* reciviendo capacidades de la tarjeta*/
//---------------------------------------------------------------------

	if (-1==ioctl(cam,VIDIOCGCAP,&cap)){perror("ioctl VIDIOCGCAP");
		exit(-1);}
	printf("------------------------------------\n");
	printf("------------------------------------\n");
	printf("Nombre del dispositivo -> %s\n", cap.name);
	printf("Tipo -> %d\n", cap.type);
	printf("Canales -> %d\n", cap.channels);
	printf("Audio -> %d\n", cap.audios );
	printf("Ancho Maximo -> %d\n", cap.maxwidth );
	printf("ALto Maximo -> %d\n", cap.maxheight);
	printf("Ancho Minimo -> %d\n", cap.minwidth );
	printf("Alto minimo -> %d\n", cap.minheight );
	printf("------------------------------------\n");

//---------------------------------------------------------------------
		/* deteccion de frames grabbers*/
//---------------------------------------------------------------------

	if (-1==ioctl(cam,VIDIOCSFBUF,&buffer))printf ("No se dectecto frame grabber\n");
	else {

 		if (-1==ioctl(cam,VIDIOCGFBUF,&buffer)) {perror ("ioctl VIDIOCGFBUF");
 			exit(-1);}
  		printf("------------------------------------\n");
  		printf ("add -> %d\n", buffer.base);
  		printf ("height -> %d\n", buffer.height);
  		printf ("width -> %d\n", buffer.width);
  		printf ("depth -> %d\n", buffer.depth);
  		printf ("BPL -> %d\n", buffer.bytesperline);}
  		printf("------------------------------------\n");



//-----------------------------------------------------------------------
		/* configuracion de ventana de captura */
//-----------------------------------------------------------------------

	win.x = 0;
	win.y = 0;
	win.width = COLS;
	win.height = ROWS;
	win.clipcount = 1;
	win.chromakey = 0;
	win.flags = VIDEO_CLIPMAP_SIZE;

	if (-1== ioctl(cam, VIDIOCSWIN,&win)){perror ("ioctl VIDIOCSWIN");
		exit (-1);}


//---------------------------------------------------------------------
		/* propiedades de la imagen*/
//---------------------------------------------------------------------

	pic.depth = 24;
	pic.palette = VIDEO_PALETTE_RGB24;
	pic.brightness = 100;
	pic.contrast = 30;
	pic.whiteness = 0;
	pic.colour = 0;
	pic.hue = 0;


	if (-1==ioctl( cam, VIDIOCSPICT, &pic )){perror("ioctl VIDIOCSPICT");
		exit(-1);}

	ioctl( cam, VIDIOCGPICT, &pic );

	printf("------------------------------------\n");
	printf("brightness -> %d \n", pic.brightness/256 );
	printf("hue -> %d\n", pic.hue/256);
	printf("colour -> %d\n", pic.colour/256 );
	printf("contrast -> %d \n", pic.contrast/256 );
	printf("whiteness -> %d\n", pic.whiteness/256 );
	printf("depth -> %d\n", pic.depth );
	printf("palette -> %d \n", pic.palette );
	printf("------------------------------------\n");

//-----------------------------------------------------------------------
		/* mapeando buffer */
//------------------------------------------------------------------------


	if (-1==ioctl(cam,VIDIOCGMBUF,&vidbuf)){perror("ioctl VIDIOCGMBUF");
		exit(-1);}

	printf("------------------------------------\n");
	printf("size  -> %d\n",vidbuf.size);
	printf("frames -> %d\n",vidbuf.frames);
	printf("offsets -> %d\n",vidbuf.offsets);
	printf("------------------------------------\n");

	bigbuf = (char *)mmap(0,vidbuf.size, PROT_READ | PROT_WRITE, MAP_SHARED, cam, 0);

	mapbuf.width = COLS;
	mapbuf.height = ROWS;
	mapbuf.format = VIDEO_PALETTE_RGB24;



	for(frame=0; frame<vidbuf.frames;frame++)
	{							// habilitando ambos buffers
		mapbuf.frame = frame;				// para la captura de
		if (ioctl(cam,VIDIOCMCAPTURE, &mapbuf)<0)
		{						// imagenes.
			perror("VIDIOCMCAPTURE");
			exit(-1);
		}
	}

	frame = 0;

//---------------------------------------------------------------------
		       /* capturando*/
//---------------------------------------------------------------------
	n=COLS*ROWS*3;
	printf("\nTamao de un cuadro = %d bytes\n",n);
	while (1)
	{
		i = -1;
		while(i<0)
		{

			i= ioctl(cam,VIDIOCSYNC, &frame);	// Esperando mientras
			if(i < 0 && errno == EINTR) continue;	// el buffer este lleno
			if (i < 0)
			{					// cuando esto sucede se
				perror ("VIDIOCSYNC");		// empieza a capturar desde.
				exit(-1);			// el otro frame
			}
			break;
		}
		buf = bigbuf + vidbuf.offsets[frame];
		mapbuf.frame = frame;
		sendto(s, (buf),n, 0, (struct sockaddr*) &name, len);
		if (ioctl(cam,VIDIOCMCAPTURE, &mapbuf)<0) {
			perror("VIDIOCMCAPTURE");
			exit(-1);
		}
		frame++;
		if (frame>=vidbuf.frames) frame=0;
		//printf("\nn = %d\n",n);
	}

}

